﻿
//===========================================================================//
//                                                                           //
//  Copyright (C) 2004 - 2018                                                //
//  IDS Imaging GmbH                                                         //
//  Dimbacherstr. 6-8                                                        //
//  D-74182 Obersulm-Willsbach                                               //
//                                                                           //
//  The information in this document is subject to change without            //
//  notice and should not be construed as a commitment by IDS Imaging GmbH.  //
//  IDS Imaging GmbH does not assume any responsibility for any errors       //
//  that may appear in this document.                                        //
//                                                                           //
//  This document, or source code, is provided solely as an example          //
//  of how to utilize IDS software libraries in a sample application.        //
//  IDS Imaging GmbH does not assume any responsibility for the use or       //
//  reliability of any portion of this document or the described software.   //
//                                                                           //
//  General permission to copy or modify, but not for profit, is hereby      //
//  granted,  provided that the above copyright notice is included and       //
//  reference made to the fact that reproduction privileges were granted	 //
//	by IDS Imaging GmbH.				                                     //
//                                                                           //
//  IDS cannot assume any responsibility for the use or misuse of any        //
//  portion of this software for other than its intended diagnostic purpose	 //
//  in calibrating and testing IDS manufactured cameras and software.		 //
//                                                                           //
//===========================================================================//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;


namespace uEyeImageQueue
{
    public class WorkerAcquire
    {
        // this method will be called when the thread is started.

        public void DoWork()
        {
            uint u32Timeout = 100;

            uEye.Defines.Status statusRet = 0;

            while (!_shouldStopAcquire)
            {
                //get oldest buffer out of the queue
                if (Globals.bLive)
                {
                    statusRet = Globals.Camera.Memory.Sequence.WaitForNextImage(u32Timeout, out Globals.s32MemID, out Globals.s32SeqId);
                    if (statusRet == uEye.Defines.Status.Success)
                    {
                        // got a new image
                        System.IntPtr ptr;
                        Globals.Camera.Memory.ToIntPtr(Globals.s32MemID, out ptr);
                        Globals.Camera.Display.Render(Globals.s32MemID, Globals.displayHandle, uEye.Defines.DisplayRenderMode.FitToWindow);
                        Globals.Camera.Memory.Sequence.Unlock(Globals.s32MemID);
                    }
                }
                else
                {
                    Thread.Sleep(100);
                }



            }
            //terminating gracefully
        }
        public void RequestStopAcquire()
        {
            _shouldStopAcquire = true;
        }
        // volatile is used as hint to the compiler that this data member will be accessed by multiple threads.
        private volatile bool _shouldStopAcquire;
    }

}
